DL_GroupPrecomputation< T > Class Template Referenceabstract

DL_GroupPrecomputation interface. More...

`#include <eprecomp.h>`

## Public Types

typedef T | Element

## Public Member Functions

virtual bool | NeedConversions () const
| Determines if elements needs conversion.
virtual Element | ConvertIn (const Element &v) const
| Converts an element between representations.
virtual Element | ConvertOut (const Element &v) const
| Converts an element between representations.
virtual const AbstractGroup< Element > & | GetGroup () const =0
| Retrieves AbstractGroup interface.
virtual Element | BERDecodeElement (BufferedTransformation &bt) const =0
| Decodes element in DER format.
virtual void | DEREncodeElement (BufferedTransformation &bt, const Element &P) const =0
| Encodes element in DER format.

## Detailed Description

template<class T>
class DL_GroupPrecomputation< T >

DL_GroupPrecomputation interface.

Template Parameters

  T | Field element

Definition at line 19 of file eprecomp.h.

## Member Typedef Documentation

## Element

template<class T >

typedef T DL_GroupPrecomputation< T >::Element

Definition at line 22 of file eprecomp.h.

## Constructor & Destructor Documentation

## ~DL_GroupPrecomputation()

template<class T >

virtual DL_GroupPrecomputation< T >::~DL_GroupPrecomputation | ( |  | ) |

inline virtual

Definition at line 24 of file eprecomp.h.

## Member Function Documentation

## NeedConversions()

template<class T >

virtual bool DL_GroupPrecomputation< T >::NeedConversions | ( |  | ) | const

inline virtual

Determines if elements needs conversion.

Returns
  true if the element needs conversion, false otherwise

NeedConversions determines if an element must convert between representations.

Reimplemented in EcPrecomputation< ECP >, and ModExpPrecomputation.

Definition at line 29 of file eprecomp.h.

## ConvertIn()

template<class T >

virtual Element DL_GroupPrecomputation< T >::ConvertIn | ( | const Element & | v | ) | const

inline virtual

Converts an element between representations.

Parameters

  v | element to convert

Returns
  an element converted to an alternate representation for internal use

ConvertIn is used when an element must convert between representations.

Reimplemented in EcPrecomputation< ECP >, and ModExpPrecomputation.

Definition at line 35 of file eprecomp.h.

## ConvertOut()

template<class T >

virtual Element DL_GroupPrecomputation< T >::ConvertOut | ( | const Element & | v | ) | const

inline virtual

Converts an element between representations.

Parameters

  v | element to convert

Returns
  an element converted from an alternate representation

Reimplemented in EcPrecomputation< ECP >, and ModExpPrecomputation.

Definition at line 40 of file eprecomp.h.

## GetGroup()

template<class T >

virtual const AbstractGroup< Element > & DL_GroupPrecomputation< T >::GetGroup | ( |  | ) | const

pure virtual

Retrieves AbstractGroup interface.

Returns
  GetGroup() returns the AbstractGroup interface

Implemented in EcPrecomputation< EC2N >, EcPrecomputation< ECP >, DL_GroupPrecomputation_LUC, and ModExpPrecomputation.

## BERDecodeElement()

template<class T >

virtual Element DL_GroupPrecomputation< T >::BERDecodeElement | ( | BufferedTransformation & | bt | ) | const

pure virtual

Decodes element in DER format.

Parameters

  bt | BufferedTransformation object

Returns
  element in the group

Implemented in EcPrecomputation< EC2N >, EcPrecomputation< ECP >, DL_GroupPrecomputation_LUC, and ModExpPrecomputation.

## DEREncodeElement()

template<class T >

virtual void DL_GroupPrecomputation< T >::DEREncodeElement | ( | BufferedTransformation & | bt,
|  | const Element & | P
| ) |  | const

pure virtual

Encodes element in DER format.

Parameters

  bt | BufferedTransformation object
  P | Element to encode

Implemented in EcPrecomputation< EC2N >, EcPrecomputation< ECP >, DL_GroupPrecomputation_LUC, and ModExpPrecomputation.

The documentation for this class was generated from the following file:

- eprecomp.h